/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.amap.lidar.amapvox.visualization.controllers.loadables.meshes.base;

import java.util.Vector;
import org.joml.Vector3f;

/**
 *
 * @author Tristan Muller (tristan.muller@cirad.fr)
 */
public class VertexList {
    
    private final Vector<Vertex> vertices;
    private float[] positions;

    public VertexList() {
        this.vertices = new Vector();
        this.positions = null;
    }
    
    public final void addVertex(final Vertex vertex) {
        vertices.add(vertex);
    }
    
    public final boolean isEmpty() {
        return vertices.isEmpty();
    }
    
    public final int getLength() {
        return vertices.size();
    }
    
    public final float[] getPositions() {
        if (positions == null) {
            positions = new float[vertices.size() * 3];
            
            int index = 0;
            
            for (Vertex vertex : vertices) {
                final Vector3f position = vertex.getPosition();
                positions[index] = position.x;
                index++;
                positions[index] = position.y;
                index++;
                positions[index] = position.z;
                index++;
            }
        }
        
        return positions;
    }
    
}
