package fr.amap.lidar.amapvox.visualization.controllers.loadables.shaders;

public class SimpleShader extends Shader {
    
    /**
     * Create a new shader and load the sources of the simple shader.
     */
    public SimpleShader() {
        super();
        setVertexSources(getGLSLSources("/shaders/simple/vertex.glsl"));
        setFragmentSources(getGLSLSources("/shaders/simple/fragment.glsl"));
    }
    
    /**
     * Used to make a concurrent singleton.
     */
    private static class SingletonHolder {
        private static final SimpleShader INSTANCE = new SimpleShader();
    }

    /**
     * Get the singleton instance object.
     * @return 
     */
    public static final SimpleShader getINSTANCE() {
        return SingletonHolder.INSTANCE;
    }
    
}
