package fr.amap.lidar.amapvox.visualization.controllers.loadables.shaders;

public class SkyboxShader extends Shader {
    
    /**
     * Create a new shader and load the sources of the simple shader.
     */
    public SkyboxShader() {
        super();
        setVertexSources(getGLSLSources("/shaders/skybox/vertex.glsl"));
        setFragmentSources(getGLSLSources("/shaders/skybox/fragment.glsl"));
    }
    
    /**
     * Used to make a concurrent singleton.
     */
    private static class SingletonHolder {
        private static final SkyboxShader INSTANCE = new SkyboxShader();
    }

    /**
     * Get the singleton instance object.
     * @return 
     */
    public static final SkyboxShader getINSTANCE() {
        return SingletonHolder.INSTANCE;
    }
    
}
