package fr.amap.lidar.amapvox.visualization.controllers.loadables.textures;

import com.jogamp.common.nio.Buffers;
import com.jogamp.opengl.GL3bc;
import com.jogamp.opengl.GLContext;
import fr.amap.lidar.amapvox.visualization.controllers.loadables.Loadable;
import java.nio.IntBuffer;

public abstract class Texture extends Loadable {
    
    protected final IntBuffer tbo;
    protected final int width;
    protected final int height;

    public Texture(final int width, final int height) {
        this.tbo = Buffers.newDirectIntBuffer(1);
        this.width = width;
        this.height = height;
    }

    @Override
    protected void onLoad() {
        final GL3bc gl = GLContext.getCurrentGL().getGL3bc();
        
        gl.glGenTextures(1, tbo);
    }

    @Override
    protected void onUnload() {
        final GL3bc gl = GLContext.getCurrentGL().getGL3bc();
        
        gl.glDeleteTextures(1, tbo);
    }

}
