/*
 * This software is governed by the CeCILL-B license under French law and
 * abiding by the rules of distribution of free software. You can use, modify
 * and/ or redistribute the software under the terms of the CeCILL-B license as
 * circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 * 
 * As a counterpart to the access to the source code and rights to copy, modify
 * and redistribute granted by the license, users are provided only with a
 * limited warranty and the software's author, the holder of the economic
 * rights, and the successive licensors have only limited liability.
 * 
 * In this respect, the user's attention is drawn to the risks associated with
 * loading, using, modifying and/or developing or reproducing the software by
 * the user in light of its specific status of free software, that may mean that
 * it is complicated to manipulate, and that also therefore means that it is
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally,
 * to use and operate it in the same conditions as regards security.
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL-B license and that you accept its terms.
 */
package fr.amap.lidar.amapvox.visualization.views;

import fr.amap.lidar.amapvox.visualization.controllers.voxels.ViewType;
import java.awt.event.KeyEvent;

/**
 *
 * @author Tristan Muller (tristan.muller@cirad.fr)
 */
public class View3DInternalFrame extends javax.swing.JInternalFrame {

    /** Creates new form View3DInternalFrame */
    public View3DInternalFrame() {
        initComponents();
        initChildren();
    }

    /** This method is called from within the constructor to initialize the
     * form. WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelCommands = new javax.swing.JPanel();
        jPanelViewPosition = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jButtonViewZneg = new javax.swing.JButton();
        jButtonViewZpos = new javax.swing.JButton();
        jButtonViewYpos = new javax.swing.JButton();
        jButtonViewYneg = new javax.swing.JButton();
        jButtonViewXpos = new javax.swing.JButton();
        jButtonViewXneg = new javax.swing.JButton();
        jPanelRendering = new javax.swing.JPanel();
        jPanelInfos = new javax.swing.JPanel();
        jPanelRotate = new javax.swing.JPanel();
        jLabelRotate = new javax.swing.JLabel();
        jTextFieldRotate = new javax.swing.JTextField();
        jPanelRotate1 = new javax.swing.JPanel();
        jLabelRotate1 = new javax.swing.JLabel();
        jTextFieldRotate1 = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();

        setTitle("3D view");
        setToolTipText("Visualization panel");
        setFocusCycleRoot(false);
        setFocusable(false);
        setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/image-x-generic.png"))); // NOI18N
        setRequestFocusEnabled(false);
        setVerifyInputWhenFocusTarget(false);
        setVisible(true);

        java.awt.FlowLayout flowLayout2 = new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 0);
        flowLayout2.setAlignOnBaseline(true);
        jPanelCommands.setLayout(flowLayout2);

        jPanelViewPosition.setToolTipText("Select the view angle to see the voxel group");
        java.awt.FlowLayout flowLayout3 = new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 0);
        flowLayout3.setAlignOnBaseline(true);
        jPanelViewPosition.setLayout(flowLayout3);

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/camera-photo.png"))); // NOI18N
        jLabel1.setText("Ground position :");
        jPanelViewPosition.add(jLabel1);

        jButtonViewZneg.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/viewZneg.png"))); // NOI18N
        jButtonViewZneg.setToolTipText("Move the ground at the bottom of the view (default)");
        jButtonViewZneg.setMaximumSize(new java.awt.Dimension(44, 44));
        jButtonViewZneg.setMinimumSize(new java.awt.Dimension(44, 44));
        jButtonViewZneg.setPreferredSize(new java.awt.Dimension(44, 44));
        jButtonViewZneg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonViewZnegActionPerformed(evt);
            }
        });
        jPanelViewPosition.add(jButtonViewZneg);

        jButtonViewZpos.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/viewZpos.png"))); // NOI18N
        jButtonViewZpos.setToolTipText("Move the ground at the top of the view");
        jButtonViewZpos.setMaximumSize(new java.awt.Dimension(44, 44));
        jButtonViewZpos.setMinimumSize(new java.awt.Dimension(44, 44));
        jButtonViewZpos.setPreferredSize(new java.awt.Dimension(44, 44));
        jButtonViewZpos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonViewZposActionPerformed(evt);
            }
        });
        jPanelViewPosition.add(jButtonViewZpos);

        jButtonViewYpos.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/viewYpos.png"))); // NOI18N
        jButtonViewYpos.setToolTipText("Move the ground behind the camera");
        jButtonViewYpos.setMaximumSize(new java.awt.Dimension(44, 44));
        jButtonViewYpos.setMinimumSize(new java.awt.Dimension(44, 44));
        jButtonViewYpos.setPreferredSize(new java.awt.Dimension(44, 44));
        jButtonViewYpos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonViewYposActionPerformed(evt);
            }
        });
        jPanelViewPosition.add(jButtonViewYpos);

        jButtonViewYneg.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/viewYneg.png"))); // NOI18N
        jButtonViewYneg.setToolTipText("Move the ground in of the camera");
        jButtonViewYneg.setMaximumSize(new java.awt.Dimension(44, 44));
        jButtonViewYneg.setMinimumSize(new java.awt.Dimension(44, 44));
        jButtonViewYneg.setPreferredSize(new java.awt.Dimension(44, 44));
        jButtonViewYneg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonViewYnegActionPerformed(evt);
            }
        });
        jPanelViewPosition.add(jButtonViewYneg);

        jButtonViewXpos.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/viewXpos.png"))); // NOI18N
        jButtonViewXpos.setToolTipText("Move the ground at the left of the view");
        jButtonViewXpos.setMaximumSize(new java.awt.Dimension(44, 44));
        jButtonViewXpos.setMinimumSize(new java.awt.Dimension(44, 44));
        jButtonViewXpos.setPreferredSize(new java.awt.Dimension(44, 44));
        jButtonViewXpos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonViewXposActionPerformed(evt);
            }
        });
        jPanelViewPosition.add(jButtonViewXpos);

        jButtonViewXneg.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/viewXneg.png"))); // NOI18N
        jButtonViewXneg.setToolTipText("Move the ground at the right of the view");
        jButtonViewXneg.setMaximumSize(new java.awt.Dimension(44, 44));
        jButtonViewXneg.setMinimumSize(new java.awt.Dimension(44, 44));
        jButtonViewXneg.setPreferredSize(new java.awt.Dimension(44, 44));
        jButtonViewXneg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonViewXnegActionPerformed(evt);
            }
        });
        jPanelViewPosition.add(jButtonViewXneg);

        jPanelCommands.add(jPanelViewPosition);

        getContentPane().add(jPanelCommands, java.awt.BorderLayout.NORTH);

        jPanelRendering.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        jPanelRendering.setLayout(new java.awt.CardLayout());
        getContentPane().add(jPanelRendering, java.awt.BorderLayout.CENTER);

        java.awt.FlowLayout flowLayout1 = new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 25, 0);
        flowLayout1.setAlignOnBaseline(true);
        jPanelInfos.setLayout(flowLayout1);

        jPanelRotate.setToolTipText("You can rotate the Voxel Space by draging your mouse in any direction");

        jLabelRotate.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/input-mouse.png"))); // NOI18N
        jLabelRotate.setText("Rotate :");
        jPanelRotate.add(jLabelRotate);

        jTextFieldRotate.setEditable(false);
        jTextFieldRotate.setText("Left click + Mouse");
        jTextFieldRotate.setFocusable(false);
        jPanelRotate.add(jTextFieldRotate);

        jPanelInfos.add(jPanelRotate);

        jPanelRotate1.setToolTipText("You can rotate the Voxel Space by draging your mouse in any direction");

        jLabelRotate1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/input-mouse.png"))); // NOI18N
        jLabelRotate1.setText("Quick rotate :");
        jPanelRotate1.add(jLabelRotate1);

        jTextFieldRotate1.setEditable(false);
        jTextFieldRotate1.setText("Right click + Mouse");
        jTextFieldRotate1.setFocusable(false);
        jPanelRotate1.add(jTextFieldRotate1);

        jPanelInfos.add(jPanelRotate1);

        jPanel3.setToolTipText("You can zoom the view by scrolling your mouse.");

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/input-mouse.png"))); // NOI18N
        jLabel3.setText("Zoom :");
        jPanel3.add(jLabel3);

        jTextField3.setEditable(false);
        jTextField3.setText("Scroll");
        jTextField3.setFocusable(false);
        jPanel3.add(jTextField3);

        jPanelInfos.add(jPanel3);

        getContentPane().add(jPanelInfos, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonViewXnegActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonViewXnegActionPerformed
        panelVisualization.getSpace().setView(ViewType.X_NEG);
    }//GEN-LAST:event_jButtonViewXnegActionPerformed

    private void jButtonViewXposActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonViewXposActionPerformed
        panelVisualization.getSpace().setView(ViewType.X_POS);
    }//GEN-LAST:event_jButtonViewXposActionPerformed

    private void jButtonViewYnegActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonViewYnegActionPerformed
        panelVisualization.getSpace().setView(ViewType.Y_NEG);
    }//GEN-LAST:event_jButtonViewYnegActionPerformed

    private void jButtonViewYposActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonViewYposActionPerformed
        panelVisualization.getSpace().setView(ViewType.Y_POS);
    }//GEN-LAST:event_jButtonViewYposActionPerformed

    private void jButtonViewZnegActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonViewZnegActionPerformed
        panelVisualization.getSpace().setView(ViewType.Z_NEG);
    }//GEN-LAST:event_jButtonViewZnegActionPerformed

    private void jButtonViewZposActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonViewZposActionPerformed
        panelVisualization.getSpace().setView(ViewType.Z_POS);
    }//GEN-LAST:event_jButtonViewZposActionPerformed

    /**
     * This method is called after the components initialization to add their
     * children.
     */
    private void initChildren() {
        panelVisualization = new Panel3D();
//        panelVisualization.setFocusable(false);
        jPanelRendering.add(panelVisualization);
    }

    public final Panel3D getPanelVisualization() {
        return panelVisualization;
    }
    
    // Children declaration
    private Panel3D panelVisualization;
    // End of children declaration

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonViewXneg;
    private javax.swing.JButton jButtonViewXpos;
    private javax.swing.JButton jButtonViewYneg;
    private javax.swing.JButton jButtonViewYpos;
    private javax.swing.JButton jButtonViewZneg;
    private javax.swing.JButton jButtonViewZpos;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelRotate;
    private javax.swing.JLabel jLabelRotate1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanelCommands;
    private javax.swing.JPanel jPanelInfos;
    private javax.swing.JPanel jPanelRendering;
    private javax.swing.JPanel jPanelRotate;
    private javax.swing.JPanel jPanelRotate1;
    private javax.swing.JPanel jPanelViewPosition;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextFieldRotate;
    private javax.swing.JTextField jTextFieldRotate1;
    // End of variables declaration//GEN-END:variables
}
