/* Use OpenGL version 3.3 compatibility to get a wide flexibility */
#version 330 compatibility

/* attributes area */
layout (location = 0) in vec3 position;

/* Uniforms area */
uniform mat4 proj;
uniform mat4 model;

/* Out variables area */
out vec3 viewSpacePosition;

void main(void)
{
    /* Set view space position */
    viewSpacePosition = position;

    /* Set the vertex position */
    gl_Position = proj * model * vec4(position, 1.0);
}